var defaultStyles = {
  title: 'font-weight: lighter; color: gray;',
  titleDetails: 'font-weight: bold;',
  atom: 'font-weight: bold; color: royalblue;',
  oldState: 'font-weight: bold; color: gray;',
  newState: 'font-weight: bold; color: forestgreen;',
  params: 'font-weight: bold; color: mediumpurple;'
};

export function makeStateLogger() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$styles = _ref.styles,
      styles = _ref$styles === undefined ? {} : _ref$styles;

  var actualStyles = Object.assign({}, defaultStyles, styles);

  return function stateLogger(oldState, newState) {
    console.group('%cState changed', actualStyles.title);
    console.log('%cold state: ', actualStyles.oldState, oldState);
    console.log('%cnew state: ', actualStyles.newState, newState);
    console.groupEnd();
  };
}

export function makeActionLogger() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref2$styles = _ref2.styles,
      styles = _ref2$styles === undefined ? defaultStyles : _ref2$styles,
      _ref2$printAtom = _ref2.printAtom,
      printAtom = _ref2$printAtom === undefined ? false : _ref2$printAtom;

  var actualStyles = Object.assign({}, defaultStyles, styles);

  return function actionLogger(atom, action, params) {
    console.group('%cAction called: %c' + action, actualStyles.title, actualStyles.titleDetails);
    if (printAtom) console.log('%catom:      ', actualStyles.atom, atom);
    console.log('%cparams:    ', actualStyles.params, params);
    console.groupEnd();
  };
}