function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Atom } from './atom';

export var Provider = function (_React$Component) {
  _inherits(Provider, _React$Component);

  Provider.prototype.getChildContext = function getChildContext() {
    return { stateAtom: this.stateAtom };
  };

  function Provider(props, context) {
    _classCallCheck(this, Provider);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props, context));

    _this.stateAtom = props.stateAtom;
    return _this;
  }

  Provider.prototype.render = function render() {
    return React.Children.only(this.props.children);
  };

  return Provider;
}(React.Component);

Provider.propTypes = {
  stateAtom: PropTypes.instanceOf(Atom),
  children: PropTypes.node.isRequired
};
Provider.childContextTypes = {
  stateAtom: PropTypes.instanceOf(Atom)
};
var getDisplayName = function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
};

export function connect(mapStateFn, mapActionsFn) {
  var equalFn = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  if (typeof equalFn !== 'function') equalFn = function equalFn(a, b) {
    return a === b;
  };

  return function connectHOC(WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_React$PureComponent) {
      _inherits(_class, _React$PureComponent);

      function _class(props, context) {
        _classCallCheck(this, _class);

        var _this2 = _possibleConstructorReturn(this, _React$PureComponent.call(this, props, context));

        _this2.stateUpdateHandler = function () {
          if (mapStateFn) {
            var newState = mapStateFn(_this2.context.stateAtom.deref(), _this2.props);
            if (!equalFn(_this2.state, newState)) _this2.setState(newState);
          }
        };

        if (mapStateFn) _this2.state = mapStateFn(context.stateAtom.deref(), props);
        if (mapActionsFn) _this2.actions = mapActionsFn(context.stateAtom, props);

        context.stateAtom.addWatch(_this2.stateUpdateHandler);
        return _this2;
      }

      _class.prototype.componentDidMount = function componentDidMount() {
        this.refreshActions(this.props);
        this.stateUpdateHandler();
      };

      _class.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        this.refreshActions(nextProps);
        if (mapStateFn) this.setState(mapStateFn(this.context.stateAtom.deref(), nextProps));
      };

      _class.prototype.refreshActions = function refreshActions(props) {
        if (mapActionsFn) this.actions = mapActionsFn(this.context.stateAtom, props);
      };

      _class.prototype.componentWillUnmount = function componentWillUnmount() {
        this.context.stateAtom.removeWatch(this.stateUpdateHandler);
      };

      _class.prototype.render = function render() {
        return React.createElement(WrappedComponent, Object.assign({}, this.props, this.actions, this.state));
      };

      return _class;
    }(React.PureComponent), _class.displayName = 'BindAtom(' + getDisplayName(WrappedComponent) + ')', _class.contextTypes = {
      stateAtom: PropTypes.instanceOf(Atom)
    }, _temp;
  };
}

// const mapState = (state, ownProps) => ({
//  notes: state.notes,
// })
//
// const mapActions = (atom, ownProps) => ({
//   addNote: (...args) => atom.dispatch('notes.add', ...args),
// })
//
// export default connect(mapState, mapActions)(SomeComponent)