const defaultStyles = {
  title: 'font-weight: lighter; color: gray;',
  titleDetails: 'font-weight: bold;',
  atom: `font-weight: bold; color: royalblue;`,
  oldState: `font-weight: bold; color: gray;`,
  newState: `font-weight: bold; color: forestgreen;`,
  params: `font-weight: bold; color: mediumpurple;`
};

export function makeStateLogger({ styles = {} } = {}) {
  const actualStyles = Object.assign({}, defaultStyles, styles);

  return function stateLogger(oldState, newState) {
    console.group('%cState changed', actualStyles.title);
    console.log('%cold state: ', actualStyles.oldState, oldState);
    console.log('%cnew state: ', actualStyles.newState, newState);
    console.groupEnd();
  };
}

export function makeActionLogger({ styles = defaultStyles, printAtom = false } = {}) {
  const actualStyles = Object.assign({}, defaultStyles, styles);

  return function actionLogger(atom, action, params) {
    console.group(`%cAction called: %c${action}`, actualStyles.title, actualStyles.titleDetails);
    if (printAtom) console.log('%catom:      ', actualStyles.atom, atom);
    console.log('%cparams:    ', actualStyles.params, params);
    console.groupEnd();
  };
}